{% extends "plantilla.html" %}
{% load static %}
{% block contenido %}

<div class="row">

    <div class="col-md-4" style="">
        <form action="{% url 'guardar_asignatura' %}" method="post" enctype="multipart/form-data" id="frm_nueva_asignatura">
            <center><h1 class="mt-3 mx-2 text-dark"><strong>ASIGNATURAS</strong></h1></center>
            {% csrf_token %}
            <b>SELECCIONE EL CURSO:</b>
            <select class="form-control" name="curso_id" required>
                <option value="">--SELECCIONE EL CURSO--</option>
                {% for curso in cursos %}
                <option value="{{ curso.idCursoSEDP }}">{{ curso.nivelCursoSEDP }}</option>
                {% endfor %}
            </select>

            <br>

            <b>NOMBRE:</b>
            <br>
            <input type="text" name="nombre" value="" id="nombre" placeholder="Ingrese el nombre de la asignatura" class="form-control" required>
            <br>
            <b>CREDITO:</b>
            <input type="number" name="credito" value="" id="credito" placeholder="Ingrese los créditos de la asignatura" class="form-control" required>

            <br>
            <b>FECHA INICIO:</b>
            <input type="date" name="fecha_inicio" id="fecha_inicio" class="form-control" required>

            <br>
            <b>FECHA FINALIZACIÓN:</b>
            <input type="date" name="fecha_finalizacion" id="fecha_finalizacion" class="form-control" required>

            <br>
            <b>PROFESOR:</b>
            <input type="text" name="profesor" value="" id="profesor" placeholder="Ingrese el nombre del profesor" class="form-control" required>

            <br>
            <b>SILABO:</b>
            <input type="file"  name="silabo" id="silabo" accept=".pdf" required>
            <script>
              $(document).ready(function () {
                  $("#silabo").fileinput({
                    //showUpload:false
                    //showRemove: false,
                    language:'es',
                  });
              });
            </script>

            <br>
            <b>HORARIO:</b>
            <input type="text" name="horario" value="" id="horario" placeholder="Ingrese el horario de la asignatura" class="form-control" required>

            <br>
            <b>HORAS TOTAL:</b>
            <input type="number" name="horas_total" value="" id="horas_total" placeholder="Ingrese las horas totales de la asignatura" class="form-control" required>

            <br><br>
            <center>
                <button type="submit" name="button" class="btn btn-dark">Guardar</button>
                &nbsp;&nbsp;&nbsp;
                &nbsp;&nbsp;&nbsp;
                &nbsp;&nbsp;&nbsp;
                <button type="reset" name="button" class="btn btn-danger">Cancelar</button>
            </center>
        </form>
    </div>
    <div class="col-md-7">
        <div class="d-flex justify-content-center align-items-center">
            <img class="imagen img-fluid" src="{% static 'img/uni.png' %}" alt="" style="max-width: 800px; height: auto;">
        </div>
        <br>
        <table class="table table-bordered table-striped" id="tbl_asignaturas">
            <thead class="table-dark">
                <tr>
                    <th>ID</th>
                    <th>NOMBRE</th>
                    <th>CREDITO</th>
                    <th>FECHA INICIO</th>
                    <th>FECHA FINALIZACIÓN</th>
                    <th>PROFESOR</th>
                    <th>HORARIO</th>
                    <th>HORAS TOTAL</th>
                    <th>CURSO</th>
                    <th>SILABO</th>
                    <th>ACCIONES</th>
                </tr>
            </thead>
            <tbody>
                {% for asignatura in asignaturas %}
                <tr>
                    <td>{{ asignatura.idAsignaturaSEDP }}</td>
                    <td>{{ asignatura.nombreAsignaturaSEDP }}</td>
                    <td>{{ asignatura.creditoAsignaturaSEDP }}</td>
                    <td>{{ asignatura.fechaInicioAsignaturaSEDP }}</td>
                    <td>{{ asignatura.fechaFinalizacionAsignaturaSEDP }}</td>
                    <td>{{ asignatura.profesorAsignaturaSEDP }}</td>
                    <td>{{ asignatura.horarioAsignaturaSEDP }}</td>
                    <td>{{ asignatura.horasTotalAsignaturaSEDP }}</td>
                    <td>{{ asignatura.cursoSEDP.nivelCursoSEDP }}</td>
                    <td>
                        {% if asignatura.silaboAsignaturaSEDP %}
                        <object data="{{ asignatura.silaboAsignaturaSEDP.url }}" type="application/pdf" width="100%" height="500px">
                            <p><a href="{{ asignatura.silaboAsignaturaSEDP.url }}" target="_blank">Descargar PDF</a></p>
                        </object>
                        {% else %}
                        <b>N/A</b>
                        {% endif %}
                    </td>
                    <td>
                        <a href="{% url 'editar_asignatura' asignatura.idAsignaturaSEDP %}" class="btn btn-warning">Editar</a>
                        <a href="javascript:void(0)" onclick="eliminarAsignatura('{% url 'eliminar_asignatura' asignatura.idAsignaturaSEDP %}');" class="btn btn-danger">Eliminar</a>
                    </td>
                </tr>
                {% endfor %}
            </tbody>
        </table>
        <div class="d-flex justify-content-center">
            <button id="toggleChartButton" onclick="toggleChart()" class="btn btn-info">Mostrar/ocultar gráfico</button>
        </div>

        <div id="chartContainer" style="width: 50%; margin: auto; border: 2px solid black; padding: 10px; display: none;">
            <canvas id="myChart"></canvas>
        </div>

        <!-- Agregar una fila para la imagen debajo de la tabla -->
        <br>
    </div>
</div>

<script type="text/javascript">
    function eliminarAsignatura(url) {
        iziToast.question({
            timeout: 15000,
            close: true,
            overlay: true,
            displayMode: 'once',
            id: 'question',
            zindex: 999,
            title: 'CONFIRMACIÓN',
            message: '¿Está seguro de eliminar la asignatura seleccionada?',
            position: 'center',
            buttons: [
                ['<button><b>SI</b></button>', function (instance, toast) {
                    instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');
                    window.location.href = url;
                }, true],
                ['<button>NO</button>', function (instance, toast) {

                    instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');

                }],
            ]
        });
    }
</script>

<script type="text/javascript">
    $("#frm_nueva_asignatura").validate({
        rules: {
            "curso_id": {
                required: true
            },
            "nombre": {
                required: true
            },
            "credito": {
                required: true,
                number: true,
                min: 1 // Validación para asegurarse de que los créditos sean al menos 1
            },
            "fecha_inicio": {
                required: true,
                date: true, // Validación para asegurarse de que la fecha de inicio sea una fecha válida
                minDate: new Date() // Validación para asegurarse de que la fecha de inicio sea igual o posterior a la fecha actual
            },
            "fecha_finalizacion": {
                required: true,
                date: true,
                greaterThanStartDate: "#fecha_inicio" // Validación para asegurarse de que la fecha de finalización sea posterior a la fecha de inicio
            },
            "profesor": {
                required: true
            },
            "silabo": {
                required: true,
                accept: "application/pdf" // Validación para asegurarse de que el archivo seleccionado sea un PDF
            },
            "horario": {
                required: true
            },
            "horas_total": {
                required: true,
                number: true,
                min: 1
            }
        },
        messages: {
            "curso_id": {
                required: "Por favor seleccione el curso"
            },
            "nombre": {
                required: "Debe ingresar el nombre de la asignatura"
            },
            "credito": {
                required: "Debe ingresar los créditos de la asignatura",
                number: "Ingrese un valor numérico",
                min: "Los créditos deben ser al menos 1"
            },
            "fecha_inicio": {
                required: "Debe ingresar la fecha de inicio de la asignatura",
                date: "Ingrese una fecha válida",
                minDate: "La fecha de inicio debe ser igual o posterior a la fecha actual"
            },
            "fecha_finalizacion": {
                required: "Debe ingresar la fecha de finalización de la asignatura",
                date: "Ingrese una fecha válida",
                greaterThanStartDate: "La fecha de finalización debe ser posterior a la fecha de inicio"
            },
            "profesor": {
                required: "Debe ingresar el nombre del profesor"
            },
            "silabo": {
                required: "Debe seleccionar un archivo para el sílabo",
                accept: "El archivo debe ser en formato PDF"
            },
            "horario": {
                required: "Debe ingresar el horario de la asignatura"
            },
            "horas_total": {
                required: "Debe ingresar las horas totales de la asignatura",
                number: "Ingrese un valor numérico",
                min: "Las horas totales deben ser al menos 1"
            }
        }
    });

    // Función personalizada para validar que la fecha de finalización sea posterior a la fecha de inicio
    $.validator.addMethod("greaterThanStartDate", function(value, element, params) {
        var startDate = $(params).val();
        return value > startDate;
    }, "La fecha de finalización debe ser posterior a la fecha de inicio");
</script>

<script type="text/javascript">
    $('#tbl_asignaturas').DataTable({
        "language": {
            "url": "https://cdn.datatables.net/plug-ins/1.10.24/i18n/Spanish.json"
        },
        dom: 'Bfrtip',
        buttons: [
            {
                extend: 'pdfHtml5',
                messageTop: 'REPORTE DE ASIGNATURAS - DJANGO Y DATATABLES.'
            },
            'print',
            'csv'
        ]
    });
</script>

<script>
    // Define toggleChart function in the global scope
    window.toggleChart = function() {
        const chartContainer = document.getElementById('chartContainer');

        if (chartContainer.style.display === 'none') {
            chartContainer.style.display = 'block';
        } else {
            chartContainer.style.display = 'none';
        }
    };

    // Add event listener for DOMContentLoaded
    document.addEventListener('DOMContentLoaded', function () {
        const ctx = document.getElementById('myChart');

        const tiposSet = new Set();
        const asignaturasTipo = {};


        {% for asignatura in asignaturas %}
            tiposSet.add("{{ asignatura.horasTotalAsignaturaSEDP }}");
            if (!asignaturasTipo["{{ asignatura.horasTotalAsignaturaSEDP }}"]) {
                asignaturasTipo["{{ asignatura.horasTotalAsignaturaSEDP }}"] = 1;
            } else {
                asignaturasTipo["{{ asignatura.horasTotalAsignaturaSEDP }}"] += 1;
            }
        {% endfor %}

        const tiposArray = Array.from(tiposSet);
        const posiciones = tiposArray.map((tipo, index) => ({ x: index, y: asignaturasTipo[tipo] || 0 }));

        new Chart(ctx, {
            type: 'bar',
            data: {
                labels: tiposArray,
                datasets: [{
                    label: 'Cantidad de Horas',
                    data: posiciones.map(posicion => posicion.y),
                    backgroundColor: 'rgba(75, 192, 192, 0.5)',
                    borderColor: 'rgba(75, 192, 192, 1)',
                    borderWidth: 1,
                }]
            },
            options: {
                scales: {
                    x: {
                        type: 'category',
                        position: 'bottom',
                    },
                    y: {
                        beginAtZero: true,
                        max: 10,
                        stepSize: 1,
                    }
                }
            }
        });
    });
</script>




{% endblock %}
